unit U_DyeGreyClothOutList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit, cxPC,
  cxLookAndFeels, cxLookAndFeelPainters, dxSkinsCore, dxSkinsDefaultPainters,
  cxNavigator, dxDateRanges, dxBarBuiltInMenu, U_BaseList,Clipbrd,
  dxScrollbarAnnotations;

type
  TfrmDyeGreyClothOutList = class(TfrmBaseList)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label1: TLabel;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    Label3: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    C_NAME: TEdit;
    OrderNo: TEdit;
    finishDescription: TEdit;
    IOType: TComboBox;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    Label14: TLabel;
    C_ColorDepth: TEdit;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    Tv1Column2: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    Tv1OrderNo: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1F_Code: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    Tv1F_Width: TcxGridDBColumn;
    Tv1Material: TcxGridDBColumn;
    Tv1finishDescription: TcxGridDBColumn;
    Tv1DlyDate: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    Tv1F_description: TcxGridDBColumn;
    N3: TMenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure SPNameChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure OrderNoKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure N3Click(Sender: TObject);
  private
    canshu1, canshu2, FWorkshop: string;
    procedure InitGrid();
    { Private declarations }
  public
    FFSPID, FstkName: string;
    { Public declarations }
  end;

//var
 // frmPBOutList: TfrmPBOutList;

implementation

uses
  U_DataLink, U_RTFun, U_DyeGreyClothOutEdit, U_LabelPrint;

{$R *.dfm}

procedure TfrmDyeGreyClothOutList.FormDestroy(Sender: TObject);
begin
  inherited;  //frmPBOutList:=nil;
end;

procedure TfrmDyeGreyClothOutList.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then  // VK_ESCAPE 是 ESC 键的常量
  begin
    Key := 0;  // 清除按键，防止继续传递
    Close;     // 或者 ModalResult := mrCancel;
  end;
end;

procedure TfrmDyeGreyClothOutList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmDyeGreyClothOutList.FormCreate(Sender: TObject);
begin
  inherited;  //cxGrid1.Align:=alClient;
  canshu1 := Trim(DParameters1);
  canshu2 := Trim(DParameters2);
  EndDate.DateTime := SGetServerDate(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime - 90;
  FWorkshop := Trim(self.fParameters3);
end;

procedure TfrmDyeGreyClothOutList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');
      sql.Add(' from BS_Cloth_IO A');
      sql.add(' where A.IOTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', BegDate.DateTime)) + '''');
      sql.Add(' and A.IOTime<''' + Trim(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1)) + '''');
      sql.Add(' and isnull(stkName,'''')=''' + Trim(FstkName) + '''');
      SQL.Add(' and ioFlag=''出库''  ');
      if trim(FWorkshop) <> '' then
        sql.Add(' and A.Workshop=''' + trim(FWorkshop) + ''' ');
//      if cxTabControl1.TabIndex = 0 then
//      begin
//        Sql.Add(' and ZFFlag=0 ');
//      end
//      else if cxTabControl1.TabIndex = 1 then
//      begin
//        Sql.Add(' and ZFFlag=1 ');
//      end;
//      ShowMessage (sql.TEXT)  ;
      Open;
    end;
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmDyeGreyClothOutList.TBRafreshClick(Sender: TObject);
begin
  BegDate.SetFocus;
  InitGrid();
end;

procedure TfrmDyeGreyClothOutList.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(trim(Self.Caption), Tv1, '坯布出库列表');

end;

procedure TfrmDyeGreyClothOutList.ToolButton2Click(Sender: TObject);
var
  MBCIOID: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;

  MBCIOID := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin

      MBCIOID := MBCIOID + ',' + (Trim(CDS_Main.fieldbyname('BCIOID').AsString));

      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;

  try
    frmLabelPrint := TfrmLabelPrint.Create(Application);
    with frmLabelPrint do
    begin
      FLMType := 'DyeGreyClothoutPrint1';
      FFiltration1 := MBCIOID;
      if ShowModal = 1 then
      begin
//        Self.InitGrid();
      end;
    end;
  finally
    frmLabelPrint.Free;
  end;
end;

procedure TfrmDyeGreyClothOutList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmDyeGreyClothOutList.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmDyeGreyClothOutList.FormShow(Sender: TObject);
begin
  inherited;
  ReadCxGrid(trim(Self.Caption), Tv1, '坯布出库列表');
  if canshu1 = '查询' then
  begin
    TBAdd.Visible := false;
    TBEdit.Visible := false;
    TBDel.Visible := false;

  end;
  BegDate.DateTime := SGetServerDate(ADOQueryCmd) - 2;
  EndDate.DateTime := SGetServerDate(ADOQueryCmd);
  InitGrid();
  KeyPreview := True;  // 确保表单可以预览按键
end;

procedure TfrmDyeGreyClothOutList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel(FstkName + '出库列表', cxGrid2);
end;

procedure TfrmDyeGreyClothOutList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmDyeGreyClothOutList.SPNameChange(Sender: TObject);
begin
  TBFind.Click;
end;


procedure TfrmDyeGreyClothOutList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmDyeGreyClothOutList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmDyeGreyClothOutList.N3Click(Sender: TObject);
begin
  Clipboard.SetTextBuf(PChar(Trim(CDS_Main.fieldbyname(TV1.Controller.FocusedColumn.DataBinding.FilterFieldName).AsString)));
end;

procedure TfrmDyeGreyClothOutList.OrderNoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then
  begin
    TBFind.Click;
  end;

end;

procedure TfrmDyeGreyClothOutList.TBDelClick(Sender: TObject);
var
  MBCIOID: string;
begin
  if CDS_Main.IsEmpty then
    Exit;

  if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;

  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;

  MBCIOID := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin

      MBCIOID := MBCIOID + ',' + Trim(CDS_Main.fieldbyname('BCIOID').AsString);
      CDS_Main.Delete;
    end;
  end;
  CDS_Main.EnableControls;

  try
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      Sql.Clear;
      Sql.Add('exec P_BS_Cloth_Out_Del ');
      Sql.Add(' @BCIOIDS=' + quotedstr(MBCIOID));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      Open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    ADOQueryCmd.Connection.CommitTrans;

  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

procedure TfrmDyeGreyClothOutList.TBAddClick(Sender: TObject);
begin
  try
    frmDyeGreyClothOutEdit := TfrmDyeGreyClothOutEdit.Create(Application);
    with frmDyeGreyClothOutEdit do
    begin
      FBCId := '';
      FstkName := Self.FstkName;
      FWorkshop := self.FWorkshop;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmDyeGreyClothOutEdit.Free;
  end;
end;

procedure TfrmDyeGreyClothOutList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;

  with ADOQueryTemp do
  begin
    Close;
    Sql.Clear;
    Sql.Add('exec P_BS_Cloth_Out_Edit ');
    Sql.Add(' @BCIOIDS=' + quotedstr(Trim(CDS_Main.fieldbyname('BCIOID').AsString)));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  try
    frmDyeGreyClothOutEdit := TfrmDyeGreyClothOutEdit.Create(Application);
    with frmDyeGreyClothOutEdit do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('BCIOID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      FWorkshop := self.FWorkshop;
      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmDyeGreyClothOutEdit.Free;
  end;

end;


procedure TfrmDyeGreyClothOutList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

end.

